// Generated by CoffeeScript 1.10.0
var docker, util;

module.exports = function(options, callback) {
  if (options.container == null) {
    return callback(Error('Missing container parameter'));
  }
  return docker.get_provider(options, (function(_this) {
    return function(err, provider) {
      var cmd, opts;
      if (err) {
        return callback(err);
      }
      options.provider = provider;
      cmd = docker.prepare_cmd(provider, options.machine);
      if (util.isError(cmd)) {
        return callback(cmd);
      }
      cmd += 'docker kill ';
      if (options.signal != null) {
        cmd += "-s " + options.signal + " ";
      }
      cmd += options.container;
      opts = docker.get_options(cmd, options);
      return _this.execute(opts, function(err, executed, stdout, stderr) {
        return callback(err, executed, stdout, stderr);
      });
    };
  })(this));
};

docker = require('./commons');

util = require('util');
