// Generated by CoffeeScript 1.10.0
var docker, path, util;

module.exports = function(options, callback) {
  if (options.image == null) {
    return callback(Error('Missing image parameter'));
  }
  if ((options.content != null) && (options.dockerfile != null)) {
    return callback(Error('Can not build from Dockerfile and content'));
  }
  return docker.get_provider(options, (function(_this) {
    return function(err, provider) {
      var cmd, i, len, opt, opts, ref;
      if (err) {
        return callback(err);
      }
      options.provider = provider;
      cmd = docker.prepare_cmd(provider, options.machine);
      if (util.isError(cmd)) {
        return callback(cmd);
      }
      cmd += 'docker login';
      ref = ['email', 'user', 'password'];
      for (i = 0, len = ref.length; i < len; i++) {
        opt = ref[i];
        if (options[opt] != null) {
          cmd += " -" + (opt.charAt(0)) + " " + options[opt];
        }
      }
      if (options.registry != null) {
        cmd += " \"" + options.registry + "\"";
      }
      opts = docker.get_options(cmd, options);
      return _this.execute(opts, function(err, executed, stdout, stderr) {
        return callback(err, executed, stdout, stderr);
      });
    };
  })(this));
};

docker = require('./commons');

path = require('path');

util = require('util');
