// Generated by CoffeeScript 1.10.0
var docker, util;

module.exports = function(options, callback) {
  if (options.image == null) {
    return callback(Error('Missing image parameter'));
  }
  return docker.get_provider(options, (function(_this) {
    return function(err, provider) {
      var cmd, i, len, opt, opts, ref;
      if (err) {
        return callback(err);
      }
      options.provider = provider;
      cmd = docker.prepare_cmd(provider, options.machine);
      if (util.isError(cmd)) {
        return callback(cmd);
      }
      cmd += 'docker rmi ';
      ref = ['force', 'no_prune'];
      for (i = 0, len = ref.length; i < len; i++) {
        opt = ref[i];
        if (options[opt] != null) {
          cmd += "--" + (opt.replace('_', '-')) + " ";
        }
      }
      cmd += options.image;
      opts = docker.get_options(cmd, options);
      return _this.execute(opts, function(err, executed, stdout, stderr) {
        return callback(err, executed, stdout, stderr);
      });
    };
  })(this));
};

docker = require('./commons');

util = require('util');
