
mecano = require '../../src'
test = require '../test'
fs = require 'fs'

describe 'api header', ->

  scratch = test.scratch @
  
  it 'print value', (next) ->
    headers = []
    mecano
      log: (log) ->
        return unless log.type is 'HEADER'
        log.time = 0
        headers.push log
    .call
      header: 'h1 call'
      handler: ->
        @call
          header: 'h2 call'
          handler: (_, callback) -> callback()
        @touch 
          header: 'h2 touch'
          destination: "#{scratch}/file_h2"
    .touch 
      header: 'h1 touch'
      destination: "#{scratch}/file_h1"
    .then (err) ->
      return next err if err
      headers.should.eql [
        { message: 'h1 call', type: 'HEADER', depth: 1, level: 'INFO', time: 0, module: undefined, header_depth: 1, total_depth: 0 }
        { message: 'h2 call', type: 'HEADER', depth: 2, level: 'INFO', time: 0, module: undefined, header_depth: 2, total_depth: 1 }
        { message: 'h2 touch', type: 'HEADER', depth: 2, level: 'INFO', time: 0, module: undefined, header_depth: 2, total_depth: 1 }
        { message: 'h1 touch', type: 'HEADER', depth: 1, level: 'INFO', time: 0, module: undefined, header_depth: 1, total_depth: 0 }
      ]
      next()
    
